import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;

public class Main {
    public static void main(String[] args) {
	try {
	    CharStream input = new ANTLRFileStream(args[0]);
	    xmlLexerLexer lex = new xmlLexerLexer(input);

	    CommonTokenStream tokens = new CommonTokenStream(lex);
	    xmlParserParser parser = new xmlParserParser(tokens);
	    xmlParserParser.document_return root = parser.document();
	    System.out.println("tree="+((Tree)root.tree).toStringTree());

	    CommonTreeNodeStream nodes = new CommonTreeNodeStream((Tree)root.tree);
	    xmlTreeParser walker = new xmlTreeParser(nodes);
	    walker.document();
	} catch(Throwable t) {
	    System.out.println("exception: "+t);
	    t.printStackTrace();
	}
    }
}
