lexer grammar xmlLexer;

@members {
    boolean tagMode = false;
}

TAG_START_OPEN : { !tagMode }?=> '<' { tagMode = true; } ;
TAG_END_OPEN : { !tagMode }?=> '</' { tagMode = true; } ;
TAG_CLOSE : { tagMode }?=> '>' { tagMode = false; } ;
TAG_EMPTY_CLOSE : { tagMode }?=> '/>' { tagMode = false; } ;

ATTR_EQ : { tagMode }?=> '=' ;

// FIXME: Double and single quotes should be stripped from values!
// ! operator does not work for that any more. 
// How to get this done?
ATTR_VALUE : { tagMode }?=>
        ( '"' (~'"')* '"'
        | '\'' (~'\'')* '\''
        )
	;

PCDATA : { !tagMode }?=> (options {greedy=true;} : ~'<')+ ; 

GENERIC_ID 
    : { tagMode }?=>
      ( LETTER | '_' | ':') ( options {greedy=true;} : NAMECHAR )*
	;

fragment NAMECHAR
	: LETTER | DIGIT | '.' | '-' | '_' | ':'
	;

fragment DIGIT
	:	'0'..'9'
	;

fragment LETTER
	: 'a'..'z' 
	| 'A'..'Z'
	;

WS  :  { tagMode }?=>
       (' '|'\r'|'\t'|'\u000C'|'\n') {channel=99;}
    ;


